package com.loufranco.bowling;

import junit.framework.TestCase;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class BowlingTest extends TestCase
{
	private BowlingGame game;
    public BowlingTest(String name)
    {
		super(name);
    }

	public void setUp()
	{
		game = new BowlingGame();
	}

	public void testSimple()
	{
		assertEquals(game.getScore(), 0);
		assertEquals(game.getFrame(), 1);

		game.bowl(0);
		assertEquals(game.getScore(), 0);
		assertEquals(game.getFrame(), 1);

		game.bowl(0);
		assertEquals(game.getScore(), 0);
		assertEquals(game.getFrame(), 2);

		game.bowl(4);
		assertEquals(game.getScore(), 4);
		assertEquals(game.getFrame(), 2);

		game.bowl(5);
		assertEquals(game.getScore(), 9);
		assertEquals(game.getFrame(), 3);
	}

	public void testSpares()
	{
		game.bowl(9);
		assertEquals(game.getScore(), 9);
		assertEquals(game.getFrame(), 1);

		game.bowl(1);
		assertEquals(game.getScore(), 10);
		assertEquals(game.getFrame(), 2);

		assert(game.getBall(1, 0) == 9);
		assert(game.getBall(1, 1) == 1);
		assert(game.getIsSpare(1));

		game.bowl(5);
		assertEquals(game.getScore(), 20);
		assertEquals(game.getFrame(), 2);

		game.bowl(5);
		assertEquals(game.getScore(), 25);
		assertEquals(game.getFrame(), 3);

		game.bowl(6);
		assertEquals(game.getScore(), 37);
		assertEquals(game.getFrame(), 3);

		assert(game.getIsSpare(2));
		assert(!game.getIsSpare(3));
		assert(!game.getIsSpare(4));

	}

	public void testStrikes()
	{
		game.bowl(10);
		assertEquals(game.getScore(), 10);
		assertEquals(game.getFrame(), 2);
		assert(!game.getIsSpare(1));
		assert(game.getIsStrike(1));

		game.bowl(5);
		assertEquals(game.getScore(), 20);
		assertEquals(game.getFrame(), 2);

		game.bowl(4);
		assertEquals(game.getScore(), 28);
		assertEquals(game.getFrame(), 3);

	}

	public void testDoubles()
	{
		game.bowl(10);
		assertEquals(game.getScore(), 10);
		assertEquals(game.getFrame(), 2);
		assert(!game.getIsSpare(1));
		assert(game.getIsStrike(1));

		game.bowl(10);
		assertEquals(game.getScore(), 30);
		assertEquals(game.getFrame(), 3);

		game.bowl(10);
		assertEquals(game.getScore(), 60);
		assertEquals(game.getFrame(), 4);

		game.bowl(10);
		assertEquals(game.getScore(), 90);
		assertEquals(game.getFrame(), 5);



	}

}